// ChangeLog v1.0.1 
// - Fixed working with the plugin [VIP] Invisibility
// - Fixed very dark colors

#include <vip_core>

public Plugin myinfo = 
{
	name		= "[VIP] Rainbow Player",
	author	= "xstage",
	version	= "1.0.1"
};

#define NAMEFUN "Rainbow_Player"

int g_iGradient[3], gI_GradientDirection = -1;

enum
{
	RED = 0,
	GREEN,
	BLUE
}

public void OnPluginStart()
{
	if(VIP_IsVIPLoaded()) VIP_OnVIPLoaded();
}

public void OnGameFrame()
{
	if((GetGameTickCount() % 5) == 0)
	{
		GetRainbow();
		
		for(int x = 1; x < MaxClients; x++)
		{
			if(!IsClientInGame(x) || !VIP_IsClientVIP(x) || !IsPlayerAlive(x) || VIP_IsClientFeatureUse(x, "Invis"))
				continue;
				
			if(VIP_IsClientFeatureUse(x, NAMEFUN))
				SetEntityRenderColor(x, g_iGradient[RED], g_iGradient[GREEN], g_iGradient[BLUE], 255);
			else
				SetEntityRenderColor(x, 255, 255, 255, 255);
		}
	}
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(NAMEFUN, BOOL);
}

public void OnPluginEnd()
{
	VIP_UnregisterFeature(NAMEFUN);
}

void GetRainbow()
{
	switch(gI_GradientDirection)
	{
		case 0:
		{
			g_iGradient[BLUE] += 15;

			if(g_iGradient[BLUE] >= 255)
			{
				g_iGradient[BLUE] = 255;
				gI_GradientDirection = 1;
			}
		}

		case 1:
		{
			g_iGradient[RED] -= 15;

			if(g_iGradient[RED] <= 180)
			{
				g_iGradient[RED] = 180;
				gI_GradientDirection = 2;
			}
		}

		case 2:
		{
			g_iGradient[GREEN] += 15;

			if(g_iGradient[GREEN] >= 255)
			{
				g_iGradient[GREEN] = 255;
				gI_GradientDirection = 3;
			}
		}

		case 3:
		{
			g_iGradient[BLUE] -= 15;

			if(g_iGradient[BLUE] <= 0)
			{
				g_iGradient[BLUE] = 0;
				gI_GradientDirection = 4;
			}
		}

		case 4:
		{
			g_iGradient[RED] += 15;

			if(g_iGradient[RED] >= 255)
			{
				g_iGradient[RED] = 255;
				gI_GradientDirection = 5;
			}
		}

		case 5:
		{
			g_iGradient[GREEN] -= 15;

			if(g_iGradient[GREEN] <= 125)
			{
				g_iGradient[GREEN] = 125;
				gI_GradientDirection = 0;
			}
		}

		default:
		{
			g_iGradient[RED] = 255;
			gI_GradientDirection = 0;
		}
	}
}